import { PotatoBot } from './bot'
import * as Potato from './types'

export { Potato }

export * from './bot'
export * from './message'
export * from './polling'
export * from './server'
export * from './utils'

export default PotatoBot

type ParamCase<S extends string> =
  | S extends `${infer L}${infer R}`
  ? `${L extends '_' ? '-' : Lowercase<L>}${ParamCase<R>}`
  : S

type PotatoEvents = {
  [T in Exclude<keyof Potato.Update, 'update_id'> as `potato/${ParamCase<T>}`]: (input: Potato.Update[T]) => void
}

declare module '@satorijs/core' {
  interface Session {
    potato?: Potato.Update & Potato.Internal
  }

  interface Events extends PotatoEvents {}
}
